# $Id: xchain-kernel.make,v 0.3.2.1 2002/09/12 11:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES += xchain-kernel

#
# Paths and names 
#
# FIXME: make extraversion configurable!
# 
KERNEL			= linux-2.4.18
KERNEL_URL		= ftp://ftp.kernel.org/pub/linux/kernel/v2.4/$(KERNEL).tar.bz2 
KERNEL_SOURCE		= $(SRCDIR)/$(KERNEL).tar.bz2
KERNEL_DIR		= $(BUILDDIR)/$(KERNEL)
KERNEL_EXTRACT 		= bzip2 -dc

KERNEL_RMKPATCH		= patch-2.4.18-rmk7
KERNEL_RMKPATCH_URL	= ftp://ftp.arm.linux.org.uk/pub/armlinux/kernel/v2.4/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_RMKPATCH_EXTRACT	= bzip2 -dc

KERNEL_PTXPATCH		= patch-2.4.18-rmk7-ptx3
KERNEL_PTXPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_PTXPATCH)
KERNEL_PTXPATCH_URL	= http://www.pengutronix.de/software/dnp/patch-2.4.18-rmk7-ptx3
KERNEL_PTXPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_PTXPATCH_EXTRACT	= cat

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

xchain-kernel_get: $(STATEDIR)/xchain-kernel.get

$(STATEDIR)/xchain-kernel.get: 					\
	$(KERNEL_SOURCE) 					\
	$(KERNEL_RMKPATCH_SOURCE)				\
	$(KERNEL_PTXPATCH_SOURCE)
	touch $@

$(KERNEL_SOURCE):
	@echo
	@echo ----------------- 
	@echo xchain-kernel.get
	@echo -----------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_URL)

$(KERNEL_RMKPATCH_SOURCE):
	@echo
	@echo -------------------------- 
	@echo xchain-kernel-armpatch.get
	@echo --------------------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_RMKPATCH_URL)

$(KERNEL_PTXPATCH_SOURCE):
	@echo
	@echo -------------------------- 
	@echo xchain-kernel-ptxpatch.get
	@echo --------------------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_PTXPATCH_URL)


# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

xchain-kernel_extract: $(STATEDIR)/xchain-kernel.extract

$(STATEDIR)/xchain-kernel.extract: $(STATEDIR)/xchain-kernel.get
	@echo
	@echo --------------------- 
	@echo xchain-kernel.extract
	@echo ---------------------
	@echo
	$(KERNEL_EXTRACT) $(KERNEL_SOURCE) | tar -C $(BUILDDIR) -xf -
	cd $(BUILDDIR) && mv linux $(KERNEL_DIR)
	cd $(KERNEL_DIR) && 						\
		$(KERNEL_RMKPATCH_EXTRACT) $(KERNEL_RMKPATCH_SOURCE) |  \
		patch -p1
	cd $(KERNEL_DIR) && 						\
		$(KERNEL_PTXPATCH_EXTRACT) $(KERNEL_PTXPATCH_SOURCE) |	\
		patch -p1
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

xchain-kernel_prepare: $(STATEDIR)/xchain-kernel.prepare

$(STATEDIR)/xchain-kernel.prepare: $(STATEDIR)/xchain-kernel.extract
	@echo
	@echo -------------- 
	@echo KERNEL.prepare
	@echo --------------
	@echo
	echo -n 'Please supply root password for sudo: '
	[ -d $(CONFIG_PTX_CROSSCHAIN_PREFIX) ] || 			\
		$(SUDO) install -g wheel -m 0755 -o $(PTXUSER)  	\
				-d $(CONFIG_PTX_CROSSCHAIN_PREFIX)
	cp $(TOPDIR)/config/kernel/config $(KERNEL_DIR)/.config	
	perl -p -i -e 's/^ARCH := .*/ARCH := arm/' $(KERNEL_DIR)/Makefile
	perl -p -i -e 's/^CROSS_COMPILE .*/CROSS_COMPILE   = arm-linux-/' $(KERNEL_DIR)/Makefile
	PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH 		\
		make -C $(KERNEL_DIR) oldconfig dep
	# copy some header files 
	cp -f 	$(KERNEL_DIR)/include/linux/version.h			\
		$(CONFIG_PTX_CROSSCHAIN_PREFIX)/asm-arm/include/linux/	
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

xchain-kernel_compile: $(STATEDIR)/xchain-kernel.compile

$(STATEDIR)/xchain-kernel.compile: $(STATEDIR)/xchain-kernel.prepare 
	@echo
	@echo --------------------- 
	@echo xchain-kernel.prepare
	@echo ---------------------
	@echo
	make -C $(KERNEL_DIR) oldconfig dep clean bzImage modules
	toch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

xchain-kernel_install: $(STATEDIR)/xchain-kernel.install

$(STATEDIR)/xchain-kernel.install: $(STATEDIR)/xchain-kernel.compile
	@echo
	@echo --------------------- 
	@echo xchain-kernel.install
	@echo ---------------------
	@echo
	make -C $(KERNEL_DIR) oldconfig dep clean bzImage modules
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

xchain-kernel_clean: 
	rm -rf $(STATEDIR)/xchain-kernel.* $(KERNEL_DIR)

# vim: syntax=make
